# Marine

![marine version on crates.io](https://img.shields.io/crates/v/marine?color=green&style=flat-square)

Marine is a general purpose Wasm runtime that could be used in different scenarios, especially in programs based on the [entity component system](https://en.wikipedia.org/wiki/Entity_component_system) (ECS) pattern or plugin architecture. It runs multi-module WebAssembly applications with interface-types and shared-nothing linking schemes.

Fluence [nodes](https://github.com/fluencelabs/fluence) use Marine to execute Wasm services composed by compiled [Aqua](https://github.com/fluencelabs/aqua):

<p align="center" width="100%">
    <img alt="fluence stack" align="center" src="images/aqua_marine_stack.png" width="900"/>
</p>

## Documentation

To learn more about about Marine, see the [Marine Documentation](https://doc.fluence.dev/docs/knowledge_aquamarine/marine), [Marine Examples](https://github.com/fluencelabs/examples/tree/main/marine-examples) and the [Marine Quickstart](https://doc.fluence.dev/docs/quick-start/2.-hosted-services).

